/************************************************************************
 *
 * Timing utility
 *  
 * Author : Jean-Francois Huppert & Pascal Vincent
 *          LPNHE-Paris
 * e-mail : huppert@lpnhep.in2p3.fr, vincentp@in2p3.fr 
 * Date   : 23 jan 2001
 * Input :
 *   - Number of microsecond.
 * Output :
 *
 * Modified:
 *
 ************************************************************************
 * MicroWait.c
 */

#include "cpu_def.h"

void MicroWait( unsigned int timout ) 
{
  volatile unsigned int i;

  i = timout * MICROSEC;
  while (i > 0) i--;
};




