/************************************************************************
 *
 * Read from the register Calib_Led of slowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 *   - Data
 * Output :
 *
 ************************************************************************
 * 
 cPCI_Calib_Led_Register_Read
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_Calib_Led_Register_Read(int file_desc, unsigned int channel)
{
  int    wc;

    wc = ioctl(file_desc, READ_CALIB_LED);
    printf(" Zone Calib Led register :%x\n",wc);
    return(wc);

};

