/************************************************************************
 *
 * Read the register version FPGA of slowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 * Output :
 *   - version
 ************************************************************************
 * 
 cPCI_FPGA_Version_Read
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_FPGA_Version_Read(int file_desc)
{
  int wc;

  wc = ioctl(file_desc, READ_FPGAVERSION);
  printf("FPGA version : %x\n",wc);
  return(wc);
};



