/************************************************************************
 *
 * Read the register FAN status of slowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 * Output :
 *   - FAN status
 ************************************************************************
 * 
 cPCI_Fan_Status_Read
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_Fan_Status_Read(int file_desc,int *t)
{
  int wc;

  wc = ioctl(file_desc, READ_FAN_STATUS);
  *t = wc;
 // printf("FAN Status2 : %x\n",wc);
  return(wc);
};



