/************************************************************************
 *
 * Read the register GPIO Status of slowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 * Output :
 *   - GPIO Status
 ************************************************************************
 * 
 cPCI_GPIO_Status_Read
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_GPIO_Status_Read(int file_desc,int*t)
{
  int wc;

  wc = ioctl(file_desc, READ_GPIO_STATUS);
  *t =wc;
//  printf("GPIO Status : %x\n",wc);
  return(wc);
};



