/************************************************************************
 *
 * Write into the register photodiode_ctrl of slowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 *   - Data
 * Output :
 *
 ************************************************************************
 * 
 cPCI_Photodiode_Ctrl_Write
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_Photodiode_Ctrl_Write(int file_desc, unsigned int val)
{
  int    ret_val;
  
    ret_val = ioctl(file_desc, WRITE_PHOTODIODE_CTRL, val);
    if(ret_val == -1)
      printf(" incorrect\n");
    else
  //    printf(" data 0x%x written to Photodiode_Ctrl register\n", val);
    
  return(0);

};

