/************************************************************************
 *
 * Read the register Photodiode Status2 of SlowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 * Output :
 *   - status2
 ************************************************************************
 * 
 cPCI_Photodiode_Status2_Read
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_Photodiode_Status2_Read(int file_desc)
{
  int wc;

  wc = ioctl(file_desc, READ_PHOTODIODE_STATUS2);
  printf("Photodiode status 2 : %x\n",wc);
  return(wc);
};



