#include "my.h"


/* configure variable global */
int ma_socket = -1;
int ma_socketMessage=-1;
char *server_name = SERVEURNAME;
struct sockaddr_in serverSockAddr,serverSockAddrMessage;
struct hostent *serverHostEnt,*serverHostEntMessage ;
long hostAddr,hostAddrMessage;
int*** tempFanTable;  
char caseString[NB_CASE][SIZE_STRING];
char caseStringCmd[NB_CASE_CMD][SIZE_STRING];
int tempOnOff =0;
int fanOutOnOff=0;
int photodiodeOnOff=0;
int tempNbMoy =0;
int photodiodeNbMoy =0;
float seuilTemp[10];
float seuilTempDecrease[10];

int nbSeuilTemp=5;
int nbSeuilPhotodiode=3;
int autoMod;
unsigned int seuilGPOLocateTable[MAX_SEUIL];
int maskGPOLocateTable[MAX_SEUIL];
unsigned int seuilInOutGPOLocateTable0[NB_GPIO];
int maskInOutGPOLocateTable0[NB_GPIO];
unsigned int seuilInOutGPOLocateTable1[NB_GPIO];
int maskInOutGPOLocateTable1[NB_GPIO];
int directionGPIO[NB_GPIO];
unsigned int ValueOutGPIO[NB_GPIO];
unsigned int ValueInGPIO[NB_GPIO];
char descriptionGPIO[NB_GPIO][80];
int numSonde;
int val=0;
int unsigned param=0; 
int etat[NB_SENSOR];
int etatMax;
float moyTemp[NB_SENSOR][MAX_SEUIL];  
int client_socket;
float valeurMoyTemp[NB_SENSOR];
int valeurLuFan[NB_FAN];
int calculFan[NB_FAN];
int fin=1;
int file_desc;
float seuilPhotodiodeIncrease[10];
float seuilPhotodiodeDecrease[10];


char levelMessageTemp[MAX_SEUIL][20];
char levelMessagePhotodiode[MAX_SEUIL][20];
char levelMessageGPIO[20];


void configure(char* file);


void initSocket2() {
// connect to server
ma_socket=0;
connectServeur();

printf("ma_socket=%d",ma_socket);
while(ma_socket==0){
     connectServeur();          
     sleep(1);
     printf("*1\n");
     printf("ma_socket=%d",ma_socket);
}
connectServeurMessage();
while(ma_socketMessage==0){
     connectServeurMessage();
     sleep(1);
     printf("*2\n");
      printf("ma_socketMessage=%d",ma_socketMessage);
}
printf("ma_socket=%d ma_socketMessage=%d\n",ma_socket,ma_socketMessage);
}

  
int main ( void )
{
	int cpt, cpt2, cpt3;

initCaseString();

	tempFanTable = (int ***)malloc(sizeof(int**) * NB_SENSOR ); //premire dimension
	for (cpt=0;cpt<NB_SENSOR;cpt++) {
		tempFanTable[cpt] =(int**) malloc(sizeof(int *)*MAX_SEUIL );
		for (cpt2=0;cpt2<MAX_SEUIL;cpt2++)
			tempFanTable[cpt][cpt2] = (int *) malloc(sizeof(int )*NB_FAN ); // 3 dimension
	}

        
initSocket2();

pthread_t thr;
pthread_create(&thr, NULL, listenServerMessage,(void *)NULL);

while(val>=0) {
    showMenu();
    userKey();
    doCommand();
}
shutdown(ma_socket,0);
close(ma_socket);
}

int userKey() {
    char prm[128];
    int ret;

    param=-1;
    do  {
        /* On demande a l'utilisateur d'entrer son nombre. */
        printf("Enter command : ");
        fgets(prm, 10, stdin);
        /* On nettoie notre chaine et le buffer stdin. */
        clean(prm);
        /* On convertie notre chaine en entier et peux etre un parametre. */
        ret = sscanf(prm, "%d %d", &val,&param);
   } while (ret != 1);
}

int connectServeurMessage(){

bzero(&serverSockAddrMessage,sizeof(serverSockAddrMessage));
hostAddrMessage = inet_addr(SERVEURNAME);

if ( (long)hostAddrMessage != (long)-1) {
  bcopy(&hostAddrMessage,&serverSockAddrMessage.sin_addr,sizeof(hostAddrMessage));
}
else
{
  serverHostEntMessage = gethostbyname(SERVEURNAME);
  if (serverHostEntMessage == NULL)  {
    printf("pb gethost\n");
    exit(0);
  }
  bcopy(serverHostEntMessage->h_addr,&serverSockAddrMessage.sin_addr,serverHostEntMessage->h_length);
}
//printf("%d\n",serverSockAddr.sin_addr);
serverSockAddrMessage.sin_port = htons(2005);
serverSockAddrMessage.sin_family = AF_INET;

/* creation de la socket */
if ( (ma_socketMessage = socket(AF_INET,SOCK_STREAM,0)) < 0){
  printf("Pb creation socket client\n");
  ma_socketMessage=0;
  return(ma_socketMessage);
}
/* requete de connexion */
if(connect( ma_socketMessage,
            (struct sockaddr *)&serverSockAddrMessage,
            sizeof(serverSockAddrMessage)) < 0 ){
  printf("pb demande de connection\n");
  close(ma_socketMessage);
  ma_socketMessage=0;
  return(ma_socketMessage);
}
return(ma_socketMessage);
printf("ma_socketMessage=%d",ma_socketMessage);
}



int connectServeur(){

bzero(&serverSockAddr,sizeof(serverSockAddr));
hostAddr = inet_addr(SERVEURNAME);

if ( (long)hostAddr != (long)-1) {
  bcopy(&hostAddr,&serverSockAddr.sin_addr,sizeof(hostAddr));
}
else
{
  serverHostEnt = gethostbyname(SERVEURNAME);
  if (serverHostEnt == NULL)  {
    printf("pb gethost\n");
    exit(0);
  }
  bcopy(serverHostEnt->h_addr,&serverSockAddr.sin_addr,serverHostEnt->h_length);
}
//printf("%d\n",serverSockAddr.sin_addr);
serverSockAddr.sin_port = htons(2004);
serverSockAddr.sin_family = AF_INET;

/* creation de la socket */
if ( (ma_socket = socket(AF_INET,SOCK_STREAM,0)) < 0){
  printf("Pb creation socket client\n");
  ma_socket=0;
  return(ma_socket);
 // exit(0);

}
/* requete de connexion */
if(connect( ma_socket,
            (struct sockaddr *)&serverSockAddr,
            sizeof(serverSockAddr)) < 0 ){
  printf("pb demande de connection\n");
  close(ma_socket);
  ma_socket=0;
  return(ma_socket);
}
printf("connect : ma_socket=%d",ma_socket);
return(ma_socket);
}

void configure(char* file) {
        char line[512];
        char buffer[512];  

          readConfigFile(file);
          printf("\n***** fin lecture config.txt\n\0");  
          
          sprintf(line,"<%s>%d</%s>\0",caseStringCmd[1],autoMod,caseStringCmd[1]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);
          printf("\n***** fin buffer1 = %s\n\0",buffer);  
          
          sprintf(line,"<%s>%x</%s>\0",caseStringCmd[3],fanOutOnOff,caseStringCmd[3]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);
          printf("\n***** fin buffer2 = %s\n\0",buffer);  
          
          sprintf(line,"<%s>%x</%s>\0",caseStringCmd[2],tempOnOff,caseStringCmd[2]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);
          printf("\n***** fin buffer3 = %s\n\0",buffer);            
          sprintf(line,"<%s>%x</%s>\0",caseStringCmd[4],photodiodeOnOff,caseStringCmd[4]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);
          printf("\n***** fin buffer4 = %s\n\0",buffer);  
          sprintf(line,"<%s>%d</%s>\0",caseStringCmd[5],tempNbMoy,caseStringCmd[5]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);
          printf("\n***** fin buffer5 = %s\n\0",buffer);  
          sprintf(line,"<%s>%d</%s>\0",caseStringCmd[6],photodiodeNbMoy,caseStringCmd[6]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);
          printf("\n***** fin buffer6 = %s\n\0",buffer);  
          sprintf(line,"<%s>%d</%s>\0",caseStringCmd[7],nbSeuilTemp,caseStringCmd[7]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);
          printf("\n***** fin buffer7 = %s\n\0",buffer);  
          sprintf(line,"<%s>",caseStringCmd[10]);
          for(int cpt=0; cpt<nbSeuilTemp; cpt++) {
                  sprintf(line,"%s %f ,",line,seuilTemp[cpt]);
           }
          sprintf(line,"%s</%s>\n",line,caseStringCmd[10]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);
          printf("\n***** fin buffer8 = %s\n\0",buffer);  
          
          sprintf(line,"<%s>",caseStringCmd[11]);
          for(int cpt=0; cpt<nbSeuilTemp; cpt++) {
                  sprintf(line,"%s %f ,",line,seuilTempDecrease[cpt]);
          }
          sprintf(line,"%s</%s>\n",line,caseStringCmd[11]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);
          printf("\n***** fin buffer2 = %s\n\0",buffer);  
          
 		  int cpt;
		  for(cpt=0; cpt<32; cpt++) {
		    sprintf(line,"<%s>%2d ,",caseStringCmd[14],cpt+1);
		    for(int cpt3=0; cpt3<nbSeuilTemp; cpt3++) { 
              for(int cpt2=0; cpt2<16; cpt2++) {                   
                 sprintf(line,"%s%2x ,",line,tempFanTable[cpt][cpt3][cpt2]);
              }
            }
            sprintf(line,"%s</%s>\n\0",line,caseStringCmd[14]);            
            write(ma_socket,line,strlen(line)+1);
		    read(ma_socket,buffer,512);
          }   
		  sprintf(line,"<%s>%d</%s>\0",caseStringCmd[29],nbSeuilPhotodiode,caseStringCmd[29]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);

		  sprintf(line,"<%s>",caseStringCmd[30]);
          for(int cpt=0; cpt<nbSeuilPhotodiode; cpt++) {
                  sprintf(line,"%s %f ,",line,seuilPhotodiodeIncrease[cpt]);
           }
          sprintf(line,"%s</%s>\n",line,caseStringCmd[30]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);

		  sprintf(line,"<%s>",caseStringCmd[31]);
          for(int cpt=0; cpt<nbSeuilPhotodiode; cpt++) {
                  sprintf(line,"%s %f ,",line,seuilPhotodiodeDecrease[cpt]);
           }
          sprintf(line,"%s</%s>\n",line,caseStringCmd[31]);
          write(ma_socket,line,strlen(line)+1);
          read(ma_socket,buffer,512);

}

void doCommand(){
   char buffer[512];  
   char line[512];
   int cpt;
   sprintf(line,"<%s>\n",caseString[val]);
    switch (val) {
//--------------------------------------------------------------------
	  case 1:	  
          sprintf(buffer,"<%s></%s>\0",caseStringCmd[23],caseStringCmd[23]);
	      write(ma_socket,buffer,strlen(buffer)+1);
		  printf("read configure :\n");
		  for(cpt=0; cpt <5+NB_SENSOR+7; cpt++) {
			read(ma_socket,buffer,512);
			printf("%s\n",buffer);
		  }
 	break;

     case 2:
          sprintf(buffer,"<%s></%s>\0",caseStringCmd[24],caseStringCmd[24]);
	      write(ma_socket,buffer,strlen(buffer)+1);
		  read(ma_socket,buffer,512);
          printf("read temperature :\n %s\n",buffer);
 	break;
    case 3:
          sprintf(buffer,"<%s></%s>\0",caseStringCmd[21],caseStringCmd[21]);
	      write(ma_socket,buffer,strlen(buffer)+1);
		  read(ma_socket,buffer,512);
          printf("read Fan :\n %s\n",buffer);
          read(ma_socket,buffer,512);
          printf("read CalculFan :\n %s\n",buffer);          
    break;
    case 4:
          sprintf(buffer,"<%s></%s>\0",caseStringCmd[22],caseStringCmd[22]);
	      write(ma_socket,buffer,strlen(buffer)+1);
		  read(ma_socket,buffer,512);
          printf("read Temperature state :\n %s\n",buffer);
 
    break;
    case 5:
           sprintf(buffer,"<%s>0</%s>\0",caseStringCmd[20],caseStringCmd[20]);
		   write(ma_socket,buffer,strlen(buffer)+1);
		   read(ma_socket,buffer,512);
           printf("read GPIO locate table:\n %s\n",buffer);

 	break;	
    case 6:
         for(cpt=0; cpt <32; cpt++) {
           sprintf(buffer,"<%s>%2d</%s>\0",caseStringCmd[15],cpt,caseStringCmd[15]);
		   write(ma_socket,buffer,strlen(buffer)+1);
		   read(ma_socket,buffer,512);
		   usleep(100);
           printf("read tempFan locate table %d:\n %s\n",cpt,buffer);
         }
 	break;
    case 7:
		  sprintf(line,"<%s></%s>",caseStringCmd[28],caseStringCmd[28]);
		  write(ma_socket,line,strlen(line)+1);
		  read(ma_socket,buffer,512);
          printf("%s\n",buffer);
          usleep(100);
          read(ma_socket,buffer,512);
          printf("%s\n",buffer);
 	break; 	
    case 8:
          sprintf(line,"<%s></%s>",caseStringCmd[18],caseStringCmd[18]);
		  write(ma_socket,line,strlen(line)+1);
		  read(ma_socket,buffer,512);
          printf("%s\n",buffer);
 	break;
    case 9:
		  sprintf(line,"<%s></%s>",caseStringCmd[19],caseStringCmd[19]);
		  write(ma_socket,line,strlen(line)+1);
		  read(ma_socket,buffer,512);
          printf("%s\n",buffer);
 	break; 	
    case 10:
          autoMod &= ~(1);
          sprintf(line,"<%s>%d</%s>",caseStringCmd[1],autoMod,caseStringCmd[1]);
		  write(ma_socket,line,strlen(line)+1);
		  read(ma_socket,buffer,512);
          printf("%s\n",buffer);
 	break; 
    case 11:
          autoMod |= 1;
         sprintf(line,"<%s>%d</%s>",caseStringCmd[1],autoMod,caseStringCmd[1]);
		  write(ma_socket,line,strlen(line)+1);
		  read(ma_socket,buffer,512);
          printf("%s\n",buffer);
 	break;  
   case 12:
        autoMod &= ~(1<<1);
         sprintf(line,"<%s>%d</%s>",caseStringCmd[1],autoMod,caseStringCmd[1]);
		  write(ma_socket,line,strlen(line)+1);
		  read(ma_socket,buffer,512);
          printf("%s\n",buffer);
 	break; 
    case 13:
         autoMod |= (1<<1);
         sprintf(line,"<%s>%d</%s>",caseStringCmd[1],autoMod,caseStringCmd[1]);
		  write(ma_socket,line,strlen(line)+1);
		  read(ma_socket,buffer,512);
          printf("%s\n",buffer);
 	break;   	
    case 14:
         autoMod |= (1<<2);
         sprintf(line,"<%s>%d</%s>",caseStringCmd[1],autoMod,caseStringCmd[1]);
		  write(ma_socket,line,strlen(line)+1);
		  read(ma_socket,buffer,512);
          printf("%s\n",buffer);
 	break;   
    case 15:
         autoMod &= ~(1<<2);
         sprintf(line,"<%s>%d</%s>",caseStringCmd[1],autoMod,caseStringCmd[1]);
		 write(ma_socket,line,strlen(line)+1);
		 read(ma_socket,buffer,512);
         printf("%s\n",buffer);
 	break;  	
    case 16:
          sprintf(line,"<%s>0</%s>",caseStringCmd[0],caseStringCmd[0]);
          write(ma_socket,line,strlen(line)+1);
		  read(ma_socket,buffer,512);
          printf("%s\n",buffer);
 	break; 
    case 17:
          sprintf(line,"<%s>FF</%s>",caseStringCmd[0],caseStringCmd[0]);
          write(ma_socket,line,strlen(line)+1);
		  read(ma_socket,buffer,512);
          printf("%s\n",buffer);
 	break;    	
      case 18:
          configure("defaut.txt");
	break;   
      case 19:
          configure("physics.txt");
	break;
      case 20:
          configure("calib.txt");
	break;                       	
      case 21:
          configure("test.txt");
	break;
	case -1:
        sprintf(line,"<%s></%s>",caseStringCmd[16],caseStringCmd[16]);
        write(ma_socket,line,strlen(line)+1);
		read(ma_socket,buffer,512);
		val =-2;
	break;
    case -2:
		sprintf(line,"<%s></%s>",caseStringCmd[17],caseStringCmd[17]);
        write(ma_socket,line,strlen(line)+1);
		read(ma_socket,buffer,512);
        val =-2;
	break;
	default:
	  printf("defaut\n");
	  break;
	}
}

void showMenu() {
   	  printf("**************************************\n");
	  for(int cpt=0; cpt<NB_CASE; cpt++) {
           printf("%3d\t%s\n",cpt,caseString[cpt]);      
      }
      printf("************************************\n");
	  printf("  -1  quit the program\n");
	  printf("  -2  quit the program and kill the serveur \n");
}



void *listenServerMessage(void *toto)
{
  char buffer[255];     
  printf("Tache rentre dans le thread listenServerMessage.\n");

  while(val != -2) {  
    usleep(50000);
    read(ma_socketMessage,buffer,512);
    printf("j'ai recu une requette : %s\n",buffer);
  }
}
