/************************************************************************
 *
 * Read the register Fan Ctrl of slowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 * Output :
 *   - Fan Ctrl
 ************************************************************************
 * 
 cPCI_Fan_Ctrl_Read
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_Fan_Ctrl_Read(int file_desc)
{
  int wc;

  wc = ioctl(file_desc, READ_FAN_CTRL);
  printf("Fan Ctrl : %x\n",wc);
  return(wc);
};



