/************************************************************************
 *
 * Read the register Temperature MUX Channel Value of slowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 * Output :
 *   - Temperature MUX Channel Value
 ************************************************************************
 * 
 cPCI_Temp_MUX_VALUE_Read2
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_Temp_MUX_VALUE_Read2(int file_desc)
{
  int wc;

  wc = ioctl(file_desc, READ_TEMP_MUX_VALUE);
  printf("%2.2f\t",((wc-22.983)/2.8682));
return(wc);
};



