/************************************************************************
 *
 * Write into the register Zone_Fan_DAC of slowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 *   - Data
 * Output :
 *
 ************************************************************************
 * 
 cPCI_Zone_Fan_DAC_Register_Write
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_Zone_Fan_DAC_Register_Write(int file_desc,  unsigned int channel, unsigned int val)
{
int    ret_val;
 //printf("channel = %x, val = %x\n");
 ret_val = ioctl(file_desc, WRITE_ZONE_FAN_DAC,(val<<4)+channel); 
  if(ret_val == -1)
    printf("incorrect\n");
  else
   // printf("data 0x%x written to Zone_Fan_DAC Register number %x\n",channel + (val<<4),channel);
  return(0);
};

